var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, ElementRef, ViewContainerRef, ChangeDetectionStrategy, forwardRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { ComponentBase, applyMixins, FormBase, setValue } from '@syncfusion/ej2-ng-base';
import { NumericTextBox } from '@syncfusion/ej2-inputs';
export var inputs = ['cssClass', 'currency', 'currencyCode', 'decimals', 'enablePersistence', 'enableRtl', 'enabled', 'floatLabelType', 'format', 'locale', 'max', 'min', 'placeholder', 'readonly', 'showClearButton', 'showSpinButton', 'step', 'strictMode', 'validateDecimalOnType', 'value', 'width'];
export var outputs = ['change', 'created', 'destroyed', 'valueChange'];
export var twoWays = ['value'];
/**
 * Represents the EJ2 Angular NumericTextBox Component.
 * ```html
 * <ej-numerictextbox [value]='value'></ej-numerictextbox>
 * ```
 */
var NumericTextBoxComponent = /** @class */ (function (_super) {
    __extends(NumericTextBoxComponent, _super);
    function NumericTextBoxComponent(ngEle, viewContainerRef) {
        var _this = _super.call(this) || this;
        _this.ngEle = ngEle;
        _this.viewContainerRef = viewContainerRef;
        _this.skipFromEvent = true;
        _this.element = _this.ngEle.nativeElement;
        _this.injectedModules = _this.injectedModules || [];
        for (var i = 2; i < arguments.length; i++) {
            var injectedObj = arguments[i];
            if (injectedObj) {
                _this.injectedModules.push(injectedObj);
            }
        }
        _this.registerEvents(outputs);
        _this.addTwoWay.call(_this, twoWays);
        setValue('currentInstance', _this, _this.viewContainerRef);
        return _this;
    }
    NumericTextBoxComponent.prototype.registerOnChange = function (registerFunction) {
    };
    NumericTextBoxComponent.prototype.registerOnTouched = function (registerFunction) {
    };
    NumericTextBoxComponent.prototype.writeValue = function (value) {
    };
    NumericTextBoxComponent.prototype.setDisabledState = function (disabled) {
    };
    NumericTextBoxComponent.prototype.ngOnInit = function () {
    };
    NumericTextBoxComponent.prototype.ngAfterViewInit = function () {
    };
    NumericTextBoxComponent.prototype.ngOnDestroy = function () {
    };
    NumericTextBoxComponent.prototype.ngAfterContentChecked = function () {
    };
    NumericTextBoxComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ejs-numerictextbox',
                    inputs: inputs,
                    outputs: outputs,
                    template: '',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(function () { return NumericTextBoxComponent; }),
                            multi: true
                        }
                    ],
                    queries: {}
                },] },
    ];
    /** @nocollapse */
    NumericTextBoxComponent.ctorParameters = function () { return [
        { type: ElementRef, },
        { type: ViewContainerRef, },
    ]; };
    return NumericTextBoxComponent;
}(NumericTextBox));
export { NumericTextBoxComponent };
applyMixins(NumericTextBoxComponent, [ComponentBase, FormBase]);
//# sourceMappingURL=numerictextbox.component.js.map